require 'rubygems'
require 'png'
require "ping"

class Ecanvas < PNG::Canvas
	def initialize(sizex,sizey)
		@canvas = PNG::Canvas.new(sizex, sizey)
	end
	
	def render(file)
		png = PNG.new(@canvas)
		png.save file
	end
	
	def draw_square(posx,posy,size,color=PNG::Color::Black)
		for i in 0..size
			for j in 0..size
				@canvas[posx+i,posy+j] = color
			end 
		end
	end
end

c=Ecanvas.new(321,321)
liste=Array.new(256,nil)
liste[0]="R"
liste[255]="R"

for i in 1..255 
	if Ping.pingecho(ARGV[0]+".#{i}",2) then
		puts ARGV[0] + ".#{i} up"
		liste[i]="X"
	else
		puts ARGV[0] + ".#{i} down"
	end
end

#p liste

cote=20
compte=0
c.draw_square(0,0,320,PNG::Color::White)

for i in 0..15
	for j in 0..15
		if liste[16*i+(j)]=="X" then
			c.draw_square(j*cote,(15-i)*cote,cote,PNG::Color::Green)
			compte+=1
		elsif liste[16*i+(j)]=="R" then 
			c.draw_square(j*cote,(15-i)*cote,cote,PNG::Color::Red)
		end
	end
end

c.render 'allocation_ip.png'

puts "#{compte} ips allouées, reste #{254-compte}"
